src/Web/Areas/Admin/Controllers/RialWithdrawalRequestController.cs
using DatabaseContext.Context;
using DomainModels.Entities.Financial;
using Services.Interfaces;
using System;
using System.Web.Mvc;
using ViewModels.API;

namespace Web.Areas.Admin.Controllers
{

    [Authorize(Roles = "Administrators")]
    public class RialWithdrawalRequestController : Controller
    {

        #region props
        private readonly IUnitOfWork _uow;
        private readonly IRialWithdrawalRequestService _rialWithdrawalRequestService;
        private readonly IPaymentFileService _paymentFileService;
        #endregion

        #region ctor
        public RialWithdrawalRequestController(
            IUnitOfWork uow,
            IRialWithdrawalRequestService rialWithdrawalRequestService,
            IPaymentFileService paymentFileService)
        {
            _uow = uow;
            _rialWithdrawalRequestService = rialWithdrawalRequestService;
            _paymentFileService = paymentFileService;
        }
        #endregion


        // ---------------------------------------------- Pending Requests
        [HttpGet]
        public ActionResult PendingRequests()
        {
            return View();
        }


        [HttpGet]
        public JsonResult GetRequests(string status)
        {
            var statusName = (WithdrawalRequestStatusName)Enum.Parse(typeof(WithdrawalRequestStatusName), status);

            var list = _rialWithdrawalRequestService.GetListByStatusName(statusName);

            return Json(new ApiResultViewModel { Data = list }, JsonRequestBehavior.AllowGet);
        }


        [HttpPost]
        public JsonResult CreatePaymentFile(long[] requestIds)
        {
            // نمایش بستانکاران، انتخاب آنها، ساخت فایل برای بانک پاسارگاد
            // WarehouseTransaction و ثبت رکورد در جدول

            var paymentFile = _paymentFileService.Add(requestIds);
            _uow.SaveChanges();

            return Json(new ApiResultViewModel { Message = "فایل پرداخت با شناسه " + paymentFile.RowGuid + " با موفقیت ایجاد شد. لطفا با استفاده از فایل پرداخت ایجاد شده از طریق سامانه بانکداری مجازی بانک پاسارگاد نسبت به پرداخت مبالغ اقدام نمایید" });
        }

        // ---------------------------------------------- On Processing Requests
        [HttpGet]
        public ActionResult OnProcessingRequests()
        {
            return View();
        }

        [HttpPost]
        public JsonResult ChangeRequestsStatusToPaid(long[] requestIds)
        {
            _rialWithdrawalRequestService.ChangeStatus(requestIds, WithdrawalRequestStatusName.Paid);
            _uow.SaveChanges();

            return Json(new ApiResultViewModel());
        }

        [HttpPost]
        public JsonResult ChangeRequestsStatusToPanding(long[] requestIds)
        {
            _rialWithdrawalRequestService.ChangeStatus(requestIds, WithdrawalRequestStatusName.Pending);
            _uow.SaveChanges();

            return Json(new ApiResultViewModel());
        }


        // ---------------------------------------------- Paid Requests
        [HttpGet]
        public ActionResult PaidRequests(int? page = 1)
        {
            var list = _rialWithdrawalRequestService.GetAllByStatusName(WithdrawalRequestStatusName.Paid, page.Value);

            return View(list);
        }



        // ---------------------------------------------- Search
        [HttpGet]
        public ActionResult Search(Guid? code, int? page = 1)
        {
            var list = _rialWithdrawalRequestService.SearchByRowGuid(code, page.Value);
            return View(list);
        }

    }
}

src/Web/Areas/Admin/Views/RialWithdrawalRequest/OnProcessingRequests.cshtml
@{
    ViewBag.Title = "لیست درخواست های 'در حال پردازش' دریافت وجه ریالی";
}

<div class="alert alert-info">
    لطفا آیتم های مورد نظر خود را انتخاب و بر روی یکی از دکمه های "واریز شد" یا "تغییر وضعیت به در حال بررسی" کلیک نمایید
</div>

@Html.Partial("~/Areas/Admin/Views/Partial/_ShowMessage.cshtml")

<div class="row">
    <div class="col-lg-12">
        <button id="btnPaid" class="btn btn-return">با موفقیت واریز شد</button>
        &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
        <button id="btnNotPaid" class="btn btn-danger">تغییر وضعیت به در حال بررسی</button>
    </div>
</div>
<br />

<div class="row">
    <div class="col-lg-12">
        <table id="miyazaki" class="tbl-grid" style="width: 100%;">
            <thead>
                <tr>
                    <th>
                        <input type="checkbox" id="selectAll" /> انتخاب همه
                    </th>
                    <th>
                        کد شناسایی
                    </th>
                    <th>
                        مالک حساب
                    </th>
                    <th>
                        مبلغ
                    </th>
                    <th>
                    </th>
                    <th>
                        بانک
                    </th>
                    <th>
                        تاریخ ثبت
                    </th>
                </tr>
            </thead>
            <tbody id="rowsWrap">
            </tbody>
        </table>
        <p class="empty-label"></p>
    </div>
</div>

@section scripts {

    <script src="~/Content/lib/js/ajax.js"></script>
    <script src="~/Content/admin/js/messagebox.js"></script>
    <script>
    $(function () {

        // ------------------------------- page.load() -------------------------------
        loadRequests();



        // ---------------------------------- events -------------------------------
        $("#selectAll").change(function () {
            // انتخاب همه
            var checked = $(this).prop('checked');
            $('#rowsWrap').find('input:checkbox').prop('checked', checked);
        });

        $("#btnPaid").click(function ()
        {
            paid();
        });

        $("#btnNotPaid").click(function () {
            notPaid();
        });

        // ------------------------------- functions -------------------------------
        function loadRequests()
        {
            // لود لیست بستانکاران
            Ajax('GET', '/Admin/RialWithdrawalRequest/GetRequests', { 'status': 'OnProcessing' }, function (response, status, xhr)
            {
                $("#rowsWrap").html('');

                if (response.Data.length == 0) {
                    $(".empty-label").html('موردی یافت نشد ...');
                }
                else {
                    $(".empty-label").html('');

                    $(response.Data).each(function (index, item) {
                        $("#rowsWrap").append(
                        '<tr>\
                            <td><input type="checkbox" class="checkboxitem" value="'+ item.Id + '" /></td>\
                            <td>' + item.RowGuid + '</td>\
                            <td>' + item.UserFullName + '(' + item.UserId + ')</td>\
                            <td>' + numberWithCommas(item.Price) + ' ریال</td>\
                            <td>\
                                شبا: ' + item.ShabaNumber + '\
                            <br />\
                                حساب: ' + item.AccountNumber + '\
                            <br />\
                                کارت: ' + item.CardNumber + '\
                            </td>\
                            <td>' + item.BankName + '</td>\
                            <td>' + item.CreatedOnFa + '</td>\
                        </tr>');
                    });
                }

            }, 'json');
        }



        function paid()
        {
            // تغییر وضعیت درخواست ها به واریز شده
            var ids = getSelectedRequestIds();

            if (ids.length == 0) {
                showMessageBox('هیچ گزینه ای انتخاب نشده است');
            }
            else {
                Ajax('POST', '/Admin/RialWithdrawalRequest/ChangeRequestsStatusToPaid', { 'requestIds': ids }, function (response, status, xhr) {

                    if (response.HaveError) {
                        showMessageBox(response.Message);
                    }
                    else {
                        showMessageBox('تغییر وضعیت آیتم ها به واریز شده، با موفقیت انجام شد');
                    }

                    loadRequests();

                }, 'json');
            }

        }

        function notPaid()
        {
            // تغییر وضعیت درخواست ها به در حال بررسی
            // بروز رسانی فیلد تاریخ آپدیت
            var ids = getSelectedRequestIds();

            if (ids.length == 0) {
                showMessageBox('هیچ گزینه ای انتخاب نشده است');
            }
            else {
                Ajax('POST', '/Admin/RialWithdrawalRequest/ChangeRequestsStatusToPanding', { 'requestIds': ids }, function (response, status, xhr) {

                    if (response.HaveError) {
                        showMessageBox(response.Message);
                    }
                    else {
                        showMessageBox('تغییر وضعیت آیتم ها به در حال بررسی، با موفقیت انجام شد');
                    }

                    loadRequests();

                }, 'json');
            }

        }


        function getSelectedRequestIds()
        {
            // دریافت لیست آی دی درخواست های انتخاب شده
            var selectedRequestIds = new Array();

            $("#rowsWrap .checkboxitem:checked").each(function () {
                selectedRequestIds.push($(this).val());
            });

            return selectedRequestIds;
        }

        function numberWithCommas(x) {
            // جداکننده سه رقم سه رقم مبالغ
            return x.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
        }

    });
    </script>

}

src/Web/Areas/Admin/Views/RialWithdrawalRequest/PaidRequests.cshtml
@model PagedList<ViewModels.Financial.RialWithdrawalRequestListViewModel>


@{
    ViewBag.Title = "لیست درخواست های 'واریز شده' دریافت وجه ریالی";
}



@Html.Partial("~/Areas/Admin/Views/Partial/_ShowMessage.cshtml")

<div class="row">
    <div class="col-lg-12">
        <table id="miyazaki" class="tbl-grid" style="width: 100%;">
            <thead>
                <tr>
                    <th>
                        کد شناسایی
                    </th>
                    <th>
                        مالک حساب
                    </th>
                    <th>
                        مبلغ
                    </th>
                    <th>
                        
                    </th>
                    <th>
                        بانک
                    </th>
                    <th>
                        تاریخ ثبت درخواست
                    </th>
                    <th>
                        تاریخ پرداخت
                    </th>
                </tr>
            </thead>
            <tbody>
                @foreach (var item in Model.Data)
            {
                    <tr>
                        <td>@item.RowGuid</td>
                        <td><a style="color:#2845ea" href="/Admin/User/Detail/@item.UserId">@item.UserFullName (@item.UserId)</a></td>
                        <td>@Html.ShowNumberWithCommaSeperator(item.Price) ریال</td>
                        <td>
                            شبا: @item.ShabaNumber
                            <br />
                            حساب: @item.AccountNumber
                            <br />
                            کارت: @item.CardNumber
                        </td>
                        <td>@item.BankName</td>
                        <td>@Html.ShowDateTime(item.CreatedOn, ShamsiDateFormatType.ToPersianWithTime)</td>
                        <td>@Html.ShowDateTime(item.PayDate, ShamsiDateFormatType.ToPersianWithTime)</td>
                    </tr>
                }
            </tbody>
        </table>

        @Html.ShowEmptyLabel(Model.Data)
        @Html.ShowPagerDescription(Model)
        @Html.ShowPager(Model, Url.Action("PaidRequests"))

    </div>
</div>

src/Web/Areas/Admin/Views/RialWithdrawalRequest/PendingRequests.cshtml
@{
    ViewBag.Title = "لیست درخواست های 'در حال بررسی' دریافت وجه ریالی";
}

<div class="alert alert-info">
    لطفا آیتم های مورد نظر خود را انتخاب و بر روی دکمه پرداخت کلیک نمایید تا فایل واریز پایا ایجاد گردد
</div>

@Html.Partial("~/Areas/Admin/Views/Partial/_ShowMessage.cshtml")

<div class="row">
    <div class="col-lg-12">
        <button id="btnSave" class="btn btn-primary">پرداخت موارد انتخاب شده (ساخت فایل پرداخت پایا)</button>
    </div>
</div>
<br />

<div class="row">
    <div class="col-lg-12">
        <table id="miyazaki" class="tbl-grid" style="width: 100%;">
            <thead>
                <tr>
                    <th>
                        <input type="checkbox" id="selectAll" /> انتخاب همه
                    </th>
                    <th>
                        کد شناسایی
                    </th>
                    <th>
                        مالک حساب
                    </th>
                    <th>
                        مبلغ
                    </th>
                    <th></th>
                    <th>
                        بانک
                    </th>
                    <th>
                        تاریخ ثبت
                    </th>
                </tr>
            </thead>
            <tbody id="rowsWrap">
            </tbody>
        </table>
        <p class="empty-label"></p>
    </div>
</div>

@section scripts {

    <script src="~/Content/lib/js/ajax.js"></script>
    <script src="~/Content/admin/js/messagebox.js"></script>
    <script>
    $(function () {

        // ------------------------------- page.load() -------------------------------
        loadRequests();



        // ---------------------------------- events -------------------------------
        $("#selectAll").change(function () {
            // انتخاب همه
            var checked = $(this).prop('checked');
            $('#rowsWrap').find('input:checkbox').prop('checked', checked);
        });

        $("#btnSave").click(function ()
        {
            savePaymentFile();
        });

        // ------------------------------- functions -------------------------------
        function loadRequests()
        {
            // لود لیست بستانکاران
            Ajax('GET', '/Admin/RialWithdrawalRequest/GetRequests', { 'status' : 'Pending'}, function (response, status, xhr)
            {
                $("#rowsWrap").html('');

                if (response.Data.length == 0) {
                    $(".empty-label").html('موردی یافت نشد ...');
                }
                else {
                    $(".empty-label").html('');

                    $(response.Data).each(function (index, item) {
                        $("#rowsWrap").append(
                        '<tr>\
                            <td><input type="checkbox" class="checkboxitem" value="'+ item.Id + '" /></td>\
                            <td>' + item.RowGuid + '</td>\
                            <td>' + item.UserFullName + '(' + item.UserId + ')</td>\
                            <td>' + numberWithCommas(item.Price) + ' ریال</td>\
                            <td>\
                                شبا: ' + item.ShabaNumber + '\
                            <br />\
                                حساب: ' + item.AccountNumber + '\
                            <br />\
                                کارت: ' + item.CardNumber + '\
                            </td>\
                            <td>' + item.BankName + '</td>\
                            <td>' + item.CreatedOnFa + '</td>\
                        </tr>');
                    });
                }

            }, 'json');
        }



        function savePaymentFile()
        {
            // ساخت فایل پرداخت بانکی به کاربران، تغییر وضعیت درخواست ها
            var ids = getSelectedRequestIds();

            if (ids.length == 0) {
                showMessageBox('هیچ گزینه ای انتخاب نشده است');
            }
            else {
                Ajax('POST', '/Admin/RialWithdrawalRequest/CreatePaymentFile', { 'requestIds': ids }, function (response, status, xhr) {

                    showMessageBox(response.Message);
                    loadRequests();

                }, 'json');
            }


        }


        function getSelectedRequestIds()
        {
            // دریافت لیست آی دی درخواست های انتخاب شده
            var selectedRequestIds = new Array();

            $("#rowsWrap .checkboxitem:checked").each(function () {
                selectedRequestIds.push($(this).val());
            });

            return selectedRequestIds;
        }

        function numberWithCommas(x) {
            // جداکننده سه رقم سه رقم مبالغ
            return x.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
        }

    });
    </script>

}

src/Web/Areas/Admin/Views/RialWithdrawalRequest/Search.cshtml
@model PagedList<ViewModels.Financial.RialWithdrawalRequestListViewModel>


@{
    ViewBag.Title = "جستجو در درخواست های دریافت وجه ریالی";
}


@Html.Partial("~/Areas/Admin/Views/Partial/_ShowMessage.cshtml")


<div class="panel panel-green">
    <div class="panel-heading">جستجو بر اساس  کد شناسایی درخواست</div>
    <div class="panel-body">
        @using (Html.BeginForm("Search", "RialWithdrawalRequest", FormMethod.Get))
        {
            <div class="row">
                <div class="col-md-5">
                    <input type="submit" value="جستجو" class="btn btn-green" />
                </div>
                <div class="col-md-5">@Html.TextBox("code", "", new { @class = "form-control" })</div>
                <div class="col-md-2">کد شناسایی:</div>
            </div>
        }
    </div>
</div>

<div class="row">
    <div class="col-lg-12">
        <table id="miyazaki" class="tbl-grid" style="width: 100%;">
            <thead>
                <tr>
                    <th>
                        کد شناسایی
                    </th>
                    <th>
                        مالک حساب
                    </th>
                    <th>
                        مبلغ
                    </th>
                    <th>
                        
                    </th>
                    <th>
                        بانک
                    </th>
                    <th>
                        تاریخ ثبت درخواست
                    </th>
                    <th>
                        تاریخ پرداخت
                    </th>
                    <th>
                        وضعیت
                    </th>
                </tr>
            </thead>
            <tbody>
                @foreach (var item in Model.Data)
            {
                    <tr>
                        <td>@item.RowGuid</td>
                        <td><a style="color:#2845ea" href="/Admin/User/Detail/@item.UserId">@item.UserFullName (@item.UserId)</a></td>
                        <td>@Html.ShowNumberWithCommaSeperator(item.Price) ریال</td>
                        <td>
                            شبا: @item.ShabaNumber
                            <br />
                            حساب: @item.AccountNumber
                            <br />
                            کارت: @item.CardNumber
                        </td>
                        <td>@item.BankName</td>
                        <td>@Html.ShowDateTime(item.CreatedOn, ShamsiDateFormatType.ToPersianWithTime)</td>
                        <td>@Html.ShowDateTime(item.PayDate, ShamsiDateFormatType.ToPersianWithTime)</td>
                        <td>@Html.ShowWithdrawalRequestStatus(item.Status)</td>
                    </tr>
                }
            </tbody>
        </table>

        @Html.ShowEmptyLabel(Model.Data)
        @Html.ShowPagerDescription(Model)
        @Html.ShowPager(Model, Url.Action("PaidRequests"))

    </div>
</div>